unit Infotabs;

{ Information Tables: Retrieve BDE Driver Capabilities }

interface

uses
{$IFDEF WIN32}
  Bde,
{$ELSE}
  DbiProcs, DbiTypes,
{$ENDIF}
  DB, DBTables, Classes, SysUtils;

type

  TDriverListTable = class( TTable )
  protected
    function CreateHandle: HDBICur; override;
  end;

  TTableTypesListTable = class( TTable )
  private
    DriverName: DBINAME;
  protected
    function CreateHandle: HDBICur; override;
  public
    constructor Create( ADriverName: String; AOwner: TComponent );
  end;


  TFieldTypesListTable = class( TTable )
  private
    DriverName: DBINAME;
  protected
    function CreateHandle: HDBICur; override;
  public
    constructor Create( ADriverName: String; AOwner: TComponent );
  end;


  TIndexTypesListTable = class( TTable )
  private
    DriverName: DBINAME;
  protected
    function CreateHandle: HDBICur; override;
  public
    constructor Create( ADriverName: String; AOwner: TComponent );
  end;

implementation

{ Implementation of TDriverListTable }
function TDriverListTable.CreateHandle: HDBICur;
begin
  check( DbiOpenDriverList( Result ) );
end;


{ Implementation of TTableTypesListTable }
constructor TTableTypesListTable.create(
  ADriverName: String;
  AOwner: TComponent
);
begin
  inherited create( AOwner );
  StrPCopy( DriverName, ADriverName );
end;

function TTableTypesListTable.CreateHandle: HDBICur;
begin
  check( DbiOpenTableTypesList( driverName, Result ));
end;


{ Implementation of TFieldTypesListTable }
constructor TFieldTypesListTable.create(
  ADriverName: String;
  AOwner: TComponent
);
begin
  inherited create( AOwner );
  StrPCopy( DriverName, ADriverName );
end;

function TFieldTypesListTable.CreateHandle: HDBICur;
begin
  check( DbiOpenFieldTypesList( driverName, Nil, Result ));
end;


{ Implementation of TIndexTypesListTable }
constructor TIndexTypesListTable.create(
  ADriverName: String;
  AOwner: TComponent
);
begin
  inherited create( AOwner );
  StrPCopy( DriverName, ADriverName );
end;

function TIndexTypesListTable.CreateHandle: HDBICur;
begin
  check( DbiOpenIndexTypesList( driverName, Result ));
end;


end.
